diff --git a/contrib/ncurses/ncurses/tinfo/lib_win32con.c b/contrib/ncurses/ncurses/tinfo/lib_win32con.c
index 3c0fe8160734..2d6857aeb4a8 100644
--- a/contrib/ncurses/ncurses/tinfo/lib_win32con.c
+++ b/contrib/ncurses/ncurses/tinfo/lib_win32con.c
@@ -871,174 +855,174 @@ _nc_console_twait(
     assert(sp);
 
     TR(TRACE_IEVENT, ("start twait: hdl=%p, %d milliseconds, mode: %d",
-                      hdl, milliseconds, mode));
+		      hdl, milliseconds, mode));
 
     if (milliseconds < 0)
-        milliseconds = INFINITY;
+	milliseconds = INFINITY;
 
     memset(&inp_rec, 0, sizeof(inp_rec));
 
     while (true) {
-        if (!isNoDelay) {
-            GetSystemTimeAsFileTime(&fstart);
-            rc = WaitForSingleObject(hdl, (DWORD) milliseconds);
-            GetSystemTimeAsFileTime(&fend);
-            diff = (int) tdiff(fstart, fend);
-            milliseconds = Adjust(milliseconds, diff);
-            if (milliseconds< 0)
-                break;
-        }
-
-        if (isNoDelay || (rc == WAIT_OBJECT_0)) {
-            if (mode) {
-                nRead = 0;
-                b = GetNumberOfConsoleInputEvents(hdl, &nRead);
-                if (!b) {
-                    T(("twait:err GetNumberOfConsoleInputEvents"));
-                }
-                if (isNoDelay && b) {
-                    T(("twait: Events Available: %ld", nRead));
-                    if (nRead==0) {
-                        code = 0;
-                        goto end;
-                    } else {
-                        DWORD n = 0;
-                        INPUT_RECORD* pInpRec =
-                            TypeAlloca(INPUT_RECORD, nRead);
-                        if (pInpRec != NULL) {
-                            DWORD i;
-                            BOOL f;
-                            memset(pInpRec, 0, sizeof(INPUT_RECORD)*nRead);
-                            f = PeekConsoleInput(hdl, pInpRec, nRead, &n);
-                            if (f) {
-                                for(i = 0; i < n; i++) {
-                                    if (pInpRec[i].EventType==KEY_EVENT) {
-                                        if(pInpRec[i].Event.KeyEvent.bKeyDown) {
-                                          DWORD ctrlMask =
-                                              (pInpRec[i].Event.KeyEvent.dwControlKeyState &
-                                               IGNORE_CTRL_KEYS);
-                                          if (!ctrlMask) {
-                                              code = TW_INPUT;
-                                              goto end;
-                                          }
-                                        }
-                                    }
-                                }
-                            } else {
-                                T(("twait:err PeekConsoleInput"));
-                            }
-                            code = 0;
-                            goto end;
-                        } else {
-                            T(("twait:err could not alloca input records"));
-                        }
-                    }
-                }
-                if (b && nRead > 0) {
-                    b = PeekConsoleInput(hdl, &inp_rec, 1, &nRead);
-                    if (!b) {
-                        T(("twait:err PeekConsoleInput"));
-                    }
-                    if (b && nRead > 0) {
-                        switch (inp_rec.EventType) {
-                        case KEY_EVENT:
-                            if (mode & TW_INPUT) {
-                                WORD vk =
-                                    inp_rec.Event.KeyEvent.wVirtualKeyCode;
-                                char ch =
-                                    inp_rec.Event.KeyEvent.uChar.AsciiChar;
-                                T(("twait:event KEY_EVENT"));
-                                T(("twait vk=%d, ch=%d, keydown=%d",
-                                   vk, ch, inp_rec.Event.KeyEvent.bKeyDown));
-                                if (inp_rec.Event.KeyEvent.bKeyDown) {
-                                    T(("twait:event KeyDown"));
-                                    if (!WINCONSOLE.isTermInfoConsole &&
-                                        (0 == ch)) {
-                                        int nKey = MapKey(vk);
-                                        if (nKey < 0) {
-                                            CONSUME();
-                                            continue;
-                                        }
-                                    }
-                                    code = TW_INPUT;
-                                    goto end;
-                                } else {
-                                    CONSUME();
-                                }
-                            }
-                            continue;
-                        case MOUSE_EVENT:
-                            T(("twait:event MOUSE_EVENT"));
-                            if (decode_mouse(sp,
-                                             (inp_rec.Event.MouseEvent.dwButtonState
-                                              & BUTTON_MASK)) == 0) {
-                                CONSUME();
-                            } else if (mode & TW_MOUSE) {
-                                code = TW_MOUSE;
-                                goto end;
-                            }
-                            continue;
-                            /* e.g., FOCUS_EVENT */
-                        default:
-                            T(("twait:event Tyoe %d", inp_rec.EventType));
-                            CONSUME();
-                            _nc_console_selectActiveHandle();
-                            continue;
-                        }
-                    }
-                }
-            }
-            continue;
-        } else {
-            if (rc != WAIT_TIMEOUT) {
-                code = -1;
-                break;
-            } else {
-                code = 0;
-                break;
-            }
-        }
+	if (!isNoDelay) {
+	    GetSystemTimeAsFileTime(&fstart);
+	    rc = WaitForSingleObject(hdl, (DWORD) milliseconds);
+	    GetSystemTimeAsFileTime(&fend);
+	    diff = (int) tdiff(fstart, fend);
+	    milliseconds = Adjust(milliseconds, diff);
+	    if (milliseconds < 0)
+		break;
+	}
+
+	if (isNoDelay || (rc == WAIT_OBJECT_0)) {
+	    if (mode) {
+		nRead = 0;
+		b = GetNumberOfConsoleInputEvents(hdl, &nRead);
+		if (!b) {
+		    T(("twait:err GetNumberOfConsoleInputEvents"));
+		}
+		if (isNoDelay && b) {
+		    T(("twait: Events Available: %ld", nRead));
+		    if (nRead == 0) {
+			code = 0;
+			goto end;
+		    } else {
+			DWORD n = 0;
+			INPUT_RECORD *pInpRec =
+			TypeAlloca(INPUT_RECORD, nRead);
+			if (pInpRec != NULL) {
+			    DWORD i;
+			    BOOL f;
+			    memset(pInpRec, 0, sizeof(INPUT_RECORD) * nRead);
+			    f = PeekConsoleInput(hdl, pInpRec, nRead, &n);
+			    if (f) {
+				for (i = 0; i < n; i++) {
+				    if (pInpRec[i].EventType == KEY_EVENT) {
+					if (pInpRec[i].Event.KeyEvent.bKeyDown) {
+					    DWORD ctrlMask =
+					    (pInpRec[i].Event.KeyEvent.dwControlKeyState &
+					     IGNORE_CTRL_KEYS);
+					    if (!ctrlMask) {
+						code = TW_INPUT;
+						goto end;
+					    }
+					}
+				    }
+				}
+			    } else {
+				T(("twait:err PeekConsoleInput"));
+			    }
+			    code = 0;
+			    goto end;
+			} else {
+			    T(("twait:err could not alloca input records"));
+			}
+		    }
+		}
+		if (b && nRead > 0) {
+		    b = PeekConsoleInput(hdl, &inp_rec, 1, &nRead);
+		    if (!b) {
+			T(("twait:err PeekConsoleInput"));
+		    }
+		    if (b && nRead > 0) {
+			switch (inp_rec.EventType) {
+			case KEY_EVENT:
+			    if (mode & TW_INPUT) {
+				WORD vk =
+				inp_rec.Event.KeyEvent.wVirtualKeyCode;
+				char ch =
+				inp_rec.Event.KeyEvent.uChar.AsciiChar;
+				T(("twait:event KEY_EVENT"));
+				T(("twait vk=%d, ch=%d, keydown=%d",
+				   vk, ch, inp_rec.Event.KeyEvent.bKeyDown));
+				if (inp_rec.Event.KeyEvent.bKeyDown) {
+				    T(("twait:event KeyDown"));
+				    if (!WINCONSOLE.isTermInfoConsole &&
+					(0 == ch)) {
+					int nKey = MapKey(vk);
+					if (nKey < 0) {
+					    CONSUME();
+					    continue;
+					}
+				    }
+				    code = TW_INPUT;
+				    goto end;
+				} else {
+				    CONSUME();
+				}
+			    }
+			    continue;
+			case MOUSE_EVENT:
+			    T(("twait:event MOUSE_EVENT"));
+			    if (decode_mouse(sp,
+					     (inp_rec.Event.MouseEvent.dwButtonState
+					      & BUTTON_MASK)) == 0) {
+				CONSUME();
+			    } else if (mode & TW_MOUSE) {
+				code = TW_MOUSE;
+				goto end;
+			    }
+			    continue;
+			    /* e.g., FOCUS_EVENT */
+			default:
+			    T(("twait:event Tyoe %d", inp_rec.EventType));
+			    CONSUME();
+			    _nc_console_selectActiveHandle();
+			    continue;
+			}
+		    }
+		}
+	    }
+	    continue;
+	} else {
+	    if (rc != WAIT_TIMEOUT) {
+		code = -1;
+		break;
+	    } else {
+		code = 0;
+		break;
+	    }
+	}
     }
-end:
+  end:
 
     TR(TRACE_IEVENT, ("end twait: returned %d (%lu), remaining time %d msec",
-                      code, GetLastError(), milliseconds));
+		      code, GetLastError(), milliseconds));
 
     if (timeleft)
-        *timeleft = milliseconds;
+	*timeleft = milliseconds;
 
     return code;
 }
 
 NCURSES_EXPORT(int)
 _nc_console_testmouse(
-                      SCREEN *sp,
-                      HANDLE hdl,
-                      int delay
-                      EVENTLIST_2nd(_nc_eventlist * evl))
+			 SCREEN *sp,
+			 HANDLE hdl,
+			 int delay
+			 EVENTLIST_2nd(_nc_eventlist * evl))
 {
     int rc = 0;
 
     assert(sp);
 
     if (sp->_drv_mouse_head < sp->_drv_mouse_tail) {
-        rc = TW_MOUSE;
+	rc = TW_MOUSE;
     } else {
-        rc = _nc_console_twait(sp,
-                               hdl,
-                               TWAIT_MASK,
-                               delay,
-                               (int *) 0
-                               EVENTLIST_2nd(evl));
+	rc = _nc_console_twait(sp,
+			       hdl,
+			       TWAIT_MASK,
+			       delay,
+			       (int *) 0
+			       EVENTLIST_2nd(evl));
     }
     return rc;
 }
 
 NCURSES_EXPORT(int)
 _nc_console_read(
-                 SCREEN *sp,
-                 HANDLE hdl,
-                 int *buf)
+		    SCREEN *sp,
+		    HANDLE hdl,
+		    int *buf)
 {
     int rc = -1;
     INPUT_RECORD inp_rec;
@@ -1054,47 +1038,47 @@ _nc_console_read(
     T((T_CALLED("lib_win32con::_nc_console_read(%p)"), sp));
 
     while ((b = ReadConsoleInput(hdl, &inp_rec, 1, &nRead))) {
-        if (b && nRead > 0) {
-            if (rc < 0)
-                rc = 0;
-            rc = rc + (int) nRead;
-            if (inp_rec.EventType == KEY_EVENT) {
-                if (!inp_rec.Event.KeyEvent.bKeyDown)
-                    continue;
-                *buf = (int) inp_rec.Event.KeyEvent.uChar.AsciiChar;
-                vk = inp_rec.Event.KeyEvent.wVirtualKeyCode;
-                /*
-                 * There are 24 virtual function-keys, and typically
-                 * 12 function-keys on a keyboard.  Use the shift-modifier
-                 * to provide the remaining 12 keys.
-                 */
-                if (vk >= VK_F1 && vk <= VK_F12) {
-                    if (inp_rec.Event.KeyEvent.dwControlKeyState &
-                        SHIFT_PRESSED) {
-                        vk = (WORD) (vk + 12);
-                    }
-                }
-                if (*buf == 0) {
-                    int key = MapKey(vk);
-                    if (key < 0)
-                        continue;
-                    if (sp->_keypad_on) {
-                        *buf = key;
-                    } else {
-                        ungetch('\0');
-                        *buf = AnsiKey(vk);
-                    }
-                }
-                break;
-            } else if (inp_rec.EventType == MOUSE_EVENT) {
-                if (handle_mouse(sp,
-                                 inp_rec.Event.MouseEvent)) {
-                    *buf = KEY_MOUSE;
-                    break;
-                }
-            }
-            continue;
-        }
+	if (b && nRead > 0) {
+	    if (rc < 0)
+		rc = 0;
+	    rc = rc + (int) nRead;
+	    if (inp_rec.EventType == KEY_EVENT) {
+		if (!inp_rec.Event.KeyEvent.bKeyDown)
+		    continue;
+		*buf = (int) inp_rec.Event.KeyEvent.uChar.AsciiChar;
+		vk = inp_rec.Event.KeyEvent.wVirtualKeyCode;
+		/*
+		 * There are 24 virtual function-keys, and typically
+		 * 12 function-keys on a keyboard.  Use the shift-modifier
+		 * to provide the remaining 12 keys.
+		 */
+		if (vk >= VK_F1 && vk <= VK_F12) {
+		    if (inp_rec.Event.KeyEvent.dwControlKeyState &
+			SHIFT_PRESSED) {
+			vk = (WORD) (vk + 12);
+		    }
+		}
+		if (*buf == 0) {
+		    int key = MapKey(vk);
+		    if (key < 0)
+			continue;
+		    if (sp->_keypad_on) {
+			*buf = key;
+		    } else {
+			ungetch('\0');
+			*buf = AnsiKey(vk);
+		    }
+		}
+		break;
+	    } else if (inp_rec.EventType == MOUSE_EVENT) {
+		if (handle_mouse(sp,
+				 inp_rec.Event.MouseEvent)) {
+		    *buf = KEY_MOUSE;
+		    break;
+		}
+	    }
+	    continue;
+	}
     }
     returnCode(rc);
 }
@@ -1115,16 +1099,17 @@ _nc_console_isatty(int fd)
     T((T_CALLED("lib_win32con::_nc_console_isatty(%d"), fd));
 
     if (_isatty(fd))
-        result = 1;
+	result = 1;
 #ifdef _NC_CHECK_MINTTY
     else {
-        if (_nc_console_checkmintty(fd, NULL)) {
-            result = 2;
-            fprintf(stderr, "ncurses on Windows must run in a Windows console.\n");
-            fprintf(stderr, "On newer versions of Windows, the calling program should create a PTY-like.\n");
-            fprintf(stderr, "device using the CreatePseudoConsole Windows API call.\n");
-            exit(EXIT_FAILURE);
-        }
+	if (_nc_console_checkmintty(fd, NULL)) {
+	    result = 2;
+	    fprintf(stderr,
+		    "ncurses on Windows must run in a Windows console.\n"
+		    "On newer versions of Windows, the calling program should create a PTY-like.\n"
+		    "device using the CreatePseudoConsole Windows API call.\n");
+	    exit(EXIT_FAILURE);
+	}
     }
 #endif
     returnCode(result);
@@ -1139,116 +1124,127 @@ _nc_console_checkinit(bool initFlag, bool assumeTermInfo)
        initFlag, assumeTermInfo));
 
     if (!initFlag) {
-        res = console_initialized;
+	res = console_initialized;
     } else {
-        /* initialize once, or not at all */
-        if (!console_initialized) {
-            int i;
-            DWORD num_buttons;
-            WORD a;
-            BOOL buffered = FALSE;
-            BOOL b;
-
-            START_TRACE();
-            WINCONSOLE.isTermInfoConsole = assumeTermInfo;
-
-            WINCONSOLE.map = (LPDWORD)malloc(sizeof(DWORD)*MAPSIZE);
-            WINCONSOLE.rmap = (LPDWORD)malloc(sizeof(DWORD)*MAPSIZE);
-            WINCONSOLE.ansi_map = (LPDWORD)malloc(sizeof(DWORD)*MAPSIZE);
-
-            for (i = 0; i < (N_INI + FKEYS); i++) {
-                if (i < N_INI) {
-                    WINCONSOLE.rmap[i] = WINCONSOLE.map[i] =
-                        (DWORD) keylist[i];
-                    WINCONSOLE.ansi_map[i] = (DWORD) ansi_keys[i];
-                } else {
-                    WINCONSOLE.rmap[i] = WINCONSOLE.map[i] =
-                        (DWORD) GenMap((VK_F1 + (i - N_INI)),
-                                       (KEY_F(1) + (i - N_INI)));
-                    WINCONSOLE.ansi_map[i] =
-                        (DWORD) GenMap((VK_F1 + (i - N_INI)),
-                                       (';' + (i - N_INI)));
-                }
-            }
-            qsort(WINCONSOLE.ansi_map,
-                  (size_t) (MAPSIZE),
-                  sizeof(keylist[0]),
-                  keycompare);
-            qsort(WINCONSOLE.map,
-                  (size_t) (MAPSIZE),
-                  sizeof(keylist[0]),
-                  keycompare);
-            qsort(WINCONSOLE.rmap,
-                  (size_t) (MAPSIZE),
-                  sizeof(keylist[0]),
-                  rkeycompare);
-
-            if (GetNumberOfConsoleMouseButtons(&num_buttons)) {
-                WINCONSOLE.numButtons = (int) num_buttons;
-            } else {
-                WINCONSOLE.numButtons = 1;
-            }
-
-            a = _nc_console_MapColor(true, COLOR_WHITE) |
-                _nc_console_MapColor(false, COLOR_BLACK);
-            for (i = 0; i < CON_NUMPAIRS; i++)
-                WINCONSOLE.pairs[i] = a;
-
-            WINCONSOLE.inp = GetStdHandle(STD_INPUT_HANDLE);
-            WINCONSOLE.out = GetStdHandle(STD_OUTPUT_HANDLE);
-            WINCONSOLE.hdl = WINCONSOLE.out;
-
-            GetConsoleMode(WINCONSOLE.inp, &WINCONSOLE.originalMode.dwFlagIn);
-            GetConsoleMode(WINCONSOLE.out, &WINCONSOLE.originalMode.dwFlagOut);
-
-            if (!WINCONSOLE.isTermInfoConsole) {
-                b = AllocConsole();
-
-                if (!b)
-                    b = AttachConsole(ATTACH_PARENT_PROCESS);
-
-                if (getenv("NCGDB") || getenv("NCURSES_CONSOLE2")) {
-                    T(("... will not buffer console"));
-                } else {
-                    T(("... creating console buffer"));
-                    WINCONSOLE.hdl =
-                        CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
-                                                  0,
-                                                  NULL,
-                                                  CONSOLE_TEXTMODE_BUFFER,
-                                                  NULL);
-                    buffered = TRUE;
-                }
-            }
-
-            /* We set binary I/O even when using the console
-               driver to cover the situation, that the
-               TERM variable is set to #win32con, but actually
-               Windows supports virtual terminal processing.
-               So if terminfo functions are used in this setup,
-               they actually may work.
-            */
-            _setmode(fileno(stdin), _O_BINARY);
-            _setmode(fileno(stdout), _O_BINARY);
-
-            if (WINCONSOLE.hdl != INVALID_HANDLE_VALUE) {
-                WINCONSOLE.buffered = buffered;
-                _nc_console_get_SBI();
-                WINCONSOLE.save_SBI = WINCONSOLE.SBI;
-                if (!buffered) {
-                    save_original_screen();
-                    _nc_console_set_scrollback(FALSE, &WINCONSOLE.SBI);
-                }
-                GetConsoleCursorInfo(WINCONSOLE.hdl, &WINCONSOLE.save_CI);
-                T(("... initial cursor is %svisible, %d%%",
-                   (WINCONSOLE.save_CI.bVisible ? "" : "not-"),
-                   (int) WINCONSOLE.save_CI.dwSize));
-            }
-
-            WINCONSOLE.initialized = TRUE;
-            console_initialized = TRUE;
-        }
-        res = (WINCONSOLE.hdl != INVALID_HANDLE_VALUE);
+	/* initialize once, or not at all */
+	if (!console_initialized) {
+	    int i;
+	    DWORD num_buttons;
+	    WORD a;
+	    BOOL buffered = FALSE;
+	    BOOL b;
+
+	    START_TRACE();
+	    WINCONSOLE.isTermInfoConsole = assumeTermInfo;
+
+	    WINCONSOLE.map = (LPDWORD) malloc(sizeof(DWORD) * MAPSIZE);
+	    WINCONSOLE.rmap = (LPDWORD) malloc(sizeof(DWORD) * MAPSIZE);
+	    WINCONSOLE.ansi_map = (LPDWORD) malloc(sizeof(DWORD) * MAPSIZE);
+
+	    for (i = 0; i < (N_INI + FKEYS); i++) {
+		if (i < N_INI) {
+		    WINCONSOLE.rmap[i] = WINCONSOLE.map[i] =
+			(DWORD) keylist[i];
+		    WINCONSOLE.ansi_map[i] = (DWORD) ansi_keys[i];
+		} else {
+		    WINCONSOLE.rmap[i] = WINCONSOLE.map[i] =
+			(DWORD) GenMap((VK_F1 + (i - N_INI)),
+				       (KEY_F(1) + (i - N_INI)));
+		    WINCONSOLE.ansi_map[i] =
+			(DWORD) GenMap((VK_F1 + (i - N_INI)),
+				       (';' + (i - N_INI)));
+		}
+	    }
+	    qsort(WINCONSOLE.ansi_map,
+		  (size_t) (MAPSIZE),
+		  sizeof(keylist[0]),
+		  keycompare);
+	    qsort(WINCONSOLE.map,
+		  (size_t) (MAPSIZE),
+		  sizeof(keylist[0]),
+		  keycompare);
+	    qsort(WINCONSOLE.rmap,
+		  (size_t) (MAPSIZE),
+		  sizeof(keylist[0]),
+		  rkeycompare);
+
+	    if (GetNumberOfConsoleMouseButtons(&num_buttons)) {
+		WINCONSOLE.numButtons = (int) num_buttons;
+	    } else {
+		WINCONSOLE.numButtons = 1;
+	    }
+
+	    a = _nc_console_MapColor(true, COLOR_WHITE) |
+		_nc_console_MapColor(false, COLOR_BLACK);
+	    for (i = 0; i < CON_NUMPAIRS; i++)
+		WINCONSOLE.pairs[i] = a;
+
+#define SaveConsoleMode(handle, value) \
+            GetConsoleMode(WINCONSOLE.handle, &WINCONSOLE.originalMode.value)
+
+	    if (WINCONSOLE.isTermInfoConsole) {
+		WINCONSOLE.inp = GetStdHandle(STD_INPUT_HANDLE);
+		WINCONSOLE.out = GetStdHandle(STD_OUTPUT_HANDLE);
+		WINCONSOLE.hdl = WINCONSOLE.out;
+
+		SaveConsoleMode(inp, dwFlagIn);
+		SaveConsoleMode(out, dwFlagOut);
+
+	    } else {
+		b = AllocConsole();
+
+		if (!b)
+		    b = AttachConsole(ATTACH_PARENT_PROCESS);
+
+		WINCONSOLE.inp = GetDirectHandle("CONIN$", FILE_SHARE_READ);
+		WINCONSOLE.out = GetDirectHandle("CONOUT$", FILE_SHARE_WRITE);
+
+		SaveConsoleMode(inp, dwFlagIn);
+		SaveConsoleMode(out, dwFlagOut);
+
+		if (getenv("NCGDB") || getenv("NCURSES_CONSOLE2")) {
+		    WINCONSOLE.hdl = WINCONSOLE.out;
+		    T(("... will not buffer console"));
+		} else {
+		    T(("... creating console buffer"));
+		    WINCONSOLE.hdl =
+			CreateConsoleScreenBuffer(GENERIC_READ | GENERIC_WRITE,
+						  FILE_SHARE_READ | FILE_SHARE_WRITE,
+						  NULL,
+						  CONSOLE_TEXTMODE_BUFFER,
+						  NULL);
+		    buffered = TRUE;
+		}
+	    }
+
+	    /* We set binary I/O even when using the console
+	       driver to cover the situation, that the
+	       TERM variable is set to #win32con, but actually
+	       Windows supports virtual terminal processing.
+	       So if terminfo functions are used in this setup,
+	       they actually may work.
+	     */
+	    _setmode(fileno(stdin), _O_BINARY);
+	    _setmode(fileno(stdout), _O_BINARY);
+
+	    if (WINCONSOLE.hdl != INVALID_HANDLE_VALUE) {
+		WINCONSOLE.buffered = buffered;
+		_nc_console_get_SBI();
+		WINCONSOLE.save_SBI = WINCONSOLE.SBI;
+		if (!buffered) {
+		    save_original_screen();
+		    _nc_console_set_scrollback(FALSE, &WINCONSOLE.SBI);
+		}
+		GetConsoleCursorInfo(WINCONSOLE.hdl, &WINCONSOLE.save_CI);
+		T(("... initial cursor is %svisible, %d%%",
+		   (WINCONSOLE.save_CI.bVisible ? "" : "not-"),
+		   (int) WINCONSOLE.save_CI.dwSize));
+	    }
+
+	    WINCONSOLE.initialized = TRUE;
+	    console_initialized = TRUE;
+	}
+	res = (WINCONSOLE.hdl != INVALID_HANDLE_VALUE);
     }
     returnBool(res);
 }
diff --git a/contrib/ncurses/ncurses/tinfo/lib_win32util.c b/contrib/ncurses/ncurses/tinfo/lib_win32util.c
index d5bcd70199ed..c67c8ceb9862 100644
--- a/contrib/ncurses/ncurses/tinfo/lib_win32util.c
+++ b/contrib/ncurses/ncurses/tinfo/lib_win32util.c
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright 2020 Thomas E. Dickey                                          *
+ * Copyright 2020-2021,2023 Thomas E. Dickey                                *
  * Copyright 1998-2009,2010 Free Software Foundation, Inc.                  *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
@@ -34,7 +34,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: lib_win32util.c,v 1.1 2020/08/14 21:57:01 juergen Exp $")
+MODULE_ID("$Id: lib_win32util.c,v 1.4 2023/06/17 17:19:06 tom Exp $")
 
 #ifdef _NC_WINDOWS
 #include <io.h>
@@ -48,13 +48,13 @@ MODULE_ID("$Id: lib_win32util.c,v 1.1 2020/08/14 21:57:01 juergen Exp $")
 
 /*   This function tests, whether or not the ncurses application
      is running as a descendant of MSYS2/cygwin mintty terminal
-     application. mintty doesn't use Windows Console for it's screen
+     application. mintty doesn't use Windows Console for its screen
      I/O, so the native Windows _isatty doesn't recognize it as
      character device. But we can discover we are at the end of an
      Pipe and can query the server side of the pipe, looking whether
      or not this is mintty.
      For now we terminate the program if we discover that situation.
-     Althogh in theory it would be possible, to remotely manipulate
+     Although in theory it would be possible, to remotely manipulate
      the terminal state of mintty, this is out of scope for now and
      not worth the significant effort.
  */
@@ -68,10 +68,10 @@ _nc_console_checkmintty(int fd, LPHANDLE pMinTTY)
     T((T_CALLED("lib_winhelper::_nc_console_checkmintty(%d, %p)"), fd, pMinTTY));
 
     if (handle != INVALID_HANDLE_VALUE) {
-        dw = GetFileType(handle);
+	dw = GetFileType(handle);
 	if (dw == FILE_TYPE_PIPE) {
 	    if (GetNamedPipeInfo(handle, 0, 0, 0, 0)) {
-	        ULONG pPid;
+		ULONG pPid;
 		/* Requires NT6 */
 		if (GetNamedPipeServerProcessId(handle, &pPid)) {
 		    TCHAR buf[MAX_PATH];
@@ -79,8 +79,7 @@ _nc_console_checkmintty(int fd, LPHANDLE pMinTTY)
 		    /* These security attributes may allow us to
 		       create a remote thread in mintty to manipulate
 		       the terminal state remotely */
-		    HANDLE pHandle = OpenProcess(
-						 PROCESS_CREATE_THREAD
+		    HANDLE pHandle = OpenProcess(PROCESS_CREATE_THREAD
 						 | PROCESS_QUERY_INFORMATION
 						 | PROCESS_VM_OPERATION
 						 | PROCESS_VM_WRITE
@@ -88,20 +87,19 @@ _nc_console_checkmintty(int fd, LPHANDLE pMinTTY)
 						 FALSE,
 						 pPid);
 		    if (pMinTTY)
-		        *pMinTTY = INVALID_HANDLE_VALUE;
+			*pMinTTY = INVALID_HANDLE_VALUE;
 		    if (pHandle != INVALID_HANDLE_VALUE) {
-		        if ((len = GetProcessImageFileName(
-							   pHandle,
+			if ((len = GetProcessImageFileName(pHandle,
 							   buf,
 							   (DWORD)
 							   array_length(buf)))) {
 			    TCHAR *pos = _tcsrchr(buf, _T('\\'));
 			    if (pos) {
-			        pos++;
+				pos++;
 				if (_tcsnicmp(pos, _TEXT("mintty.exe"), 10)
 				    == 0) {
 				    if (pMinTTY)
-				        *pMinTTY = pHandle;
+					*pMinTTY = pHandle;
 				    code = 1;
 				}
 			    }
@@ -114,7 +112,8 @@ _nc_console_checkmintty(int fd, LPHANDLE pMinTTY)
     returnCode(code);
 }
 #endif /* _NC_CHECK_MINTTY */
-
+
+#if HAVE_GETTIMEOFDAY == 2
 #define JAN1970 116444736000000000LL	/* the value for 01/01/1970 00:00 */
 
 NCURSES_EXPORT(int)
@@ -130,5 +129,6 @@ _nc_gettimeofday(struct timeval *tv, void *tz GCC_UNUSED)
     tv->tv_sec = (long) ((data.since1601 - JAN1970) / 10000000LL);
     return (0);
 }
+#endif // HAVE_GETTIMEOFDAY == 2
 
 #endif // _NC_WINDOWS
diff --git a/contrib/ncurses/ncurses/tinfo/make_hash.c b/contrib/ncurses/ncurses/tinfo/make_hash.c
index 9980279b2d21..78a684cc8bcb 100644
--- a/contrib/ncurses/ncurses/tinfo/make_hash.c
+++ b/contrib/ncurses/ncurses/tinfo/make_hash.c
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright 2018-2019,2020 Thomas E. Dickey                                *
+ * Copyright 2018-2020,2024 Thomas E. Dickey                                *
  * Copyright 2009-2013,2017 Free Software Foundation, Inc.                  *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
@@ -44,7 +44,7 @@
 
 #include <ctype.h>
 
-MODULE_ID("$Id: make_hash.c,v 1.33 2020/02/02 23:34:34 tom Exp $")
+MODULE_ID("$Id: make_hash.c,v 1.34 2024/03/02 19:35:40 tom Exp $")
 
 /*
  *	_nc_make_hash_table()
@@ -250,7 +250,7 @@ main(int argc, char **argv)
     struct user_table_entry *name_table = typeCalloc(struct
 						     user_table_entry, tablesize);
     HashValue *hash_table = typeCalloc(HashValue, HASHTABSIZE);
-    const char *root_name = "";
+    const char *root_name;
     int column = 0;
     int bigstring = 0;
     unsigned n;
diff --git a/contrib/ncurses/ncurses/tinfo/obsolete.c b/contrib/ncurses/ncurses/tinfo/obsolete.c
index 972a9a180e78..cc62f18cb3f4 100644
--- a/contrib/ncurses/ncurses/tinfo/obsolete.c
+++ b/contrib/ncurses/ncurses/tinfo/obsolete.c
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright 2020 Thomas E. Dickey                                          *
+ * Copyright 2020,2023 Thomas E. Dickey                                     *
  * Copyright 2013-2014,2016 Free Software Foundation, Inc.                  *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
@@ -37,7 +37,7 @@
 
 #include <curses.priv.h>
 
-MODULE_ID("$Id: obsolete.c,v 1.6 2020/02/02 23:34:34 tom Exp $")
+MODULE_ID("$Id: obsolete.c,v 1.11 2023/10/21 15:38:47 tom Exp $")
 
 /*
  * Obsolete entrypoint retained for binary compatibility.
@@ -238,3 +238,98 @@ _nc_conv_to_utf32(unsigned *target, const char *source, unsigned limit)
 #undef CH
 }
 #endif /* EXP_XTERM_1005 */
+
+#ifdef EXP_OOM_TESTING
+/*
+ * Out-of-memory testing, suitable for checking if initialization (and limited
+ * running) recovers from errors due to insufficient memory.  In practice, this
+ * is unlikely except with artificially constructed tests (or poorly behaved
+ * applications).
+ */
+#undef malloc
+#undef calloc
+#undef realloc
+#undef free
+#undef strdup
+
+#define TR_OOM(stmt) T(stmt)
+
+static long oom_limit = -1;
+static long oom_count = 0;
+
+static bool
+oom_check(void)
+{
+    static bool initialized = FALSE;
+    static bool triggered = FALSE;
+    bool result = FALSE;
+
+    if (!initialized) {
+	char *env = getenv("NCURSES_OOM_TESTING");
+	initialized = TRUE;
+	if (env != NULL) {
+	    char *check;
+	    oom_limit = strtol(env, &check, 0);
+	    if (check != NULL && *check != '\0')
+		oom_limit = 0;
+	}
+    }
+    ++oom_count;
+    if (oom_limit >= 0) {
+	result = (oom_count > oom_limit);
+	if (result && !triggered) {
+	    triggered = TRUE;
+	    TR_OOM(("out-of-memory"));
+	}
+    }
+    return result;
+}
+
+NCURSES_EXPORT(void *)
+_nc_oom_malloc(size_t size)
+{
+    char *result = (oom_check()
+		    ? NULL
+		    : malloc(size));
+    TR_OOM(("oom #%ld malloc(%ld) %p", oom_count, size, result));
+    return result;
+}
+
+NCURSES_EXPORT(void *)
+_nc_oom_calloc(size_t nmemb, size_t size)
+{
+    char *result = (oom_check()
+		    ? NULL
+		    : calloc(nmemb, size));
+    TR_OOM(("oom #%ld calloc(%ld, %ld) %p", oom_count, nmemb, size, result));
+    return result;
+}
+
+NCURSES_EXPORT(void *)
+_nc_oom_realloc(void *ptr, size_t size)
+{
+    char *result = (oom_check()
+		    ? NULL
+		    : realloc(ptr, size));
+    TR_OOM(("oom #%ld realloc(%p, %ld) %p", oom_count, ptr, size, result));
+    return result;
+}
+
+NCURSES_EXPORT(void)
+_nc_oom_free(void *ptr)
+{
+    ++oom_count;
+    TR_OOM(("oom #%ld free(%p)", oom_count, ptr));
+    free(ptr);
+}
+
+NCURSES_EXPORT(char *)
+_nc_oom_strdup(const char *ptr)
+{
+    char *result = (oom_check()
+		    ? NULL
+		    : strdup(ptr));
+    TR_OOM(("oom #%ld strdup(%p) %p", oom_count, ptr, result));
+    return result;
+}
+#endif /* EXP_OOM_TESTING */
